require "defines"
require "config"

glob.turret_range_entities = {}

function round(x) 
    return x + 0.5 - (x + 0.5) % 1
end

function draw_turret_range(turret_type, sx, sy, r)

    local x = 0
    local y = 0
    local angle = 0
    local drawmap = {}

    sx = round(sx) - 1
    sy = round(sy) - 1

    while angle < math.pi * 2 do

        angle = angle + 0.03
        x = round(math.cos(angle) * r + sx)
        y = round(math.sin(angle) * r + sy)

        if drawmap[x .. "x" .. y] == nil then
            drawmap[x .. "x" .. y] = true
            table.insert(glob.turret_range_entities, game.createentity{
                name = turret_type .. "-turret-range-overlay",
                position = { x = x, y = y }
            })
        end

    end

end

game.onevent(defines.events.onbuiltentity, function(event) 

    local player = game.getplayer(event.playerindex)
    local created_entity = event.createdentity
    local entity = nil
    local pos = created_entity.position
    local turret_type = ""
    local found = false

    if created_entity.name == "turret-probe" then

        player.insert{name = "turret-probe", count = 1}
        created_entity.destroy()

        entity = game.findentities{{ pos.x, pos.y }, { pos.x, pos.y }}
        if #entity > 0 then
            if turret_ranges[entity[1].name] then
                found = true
                if entity[1].type == "electric-turret" then
                    turret_type = "laser"
                else
                    turret_type = "gun"
                end
                draw_turret_range(turret_type, pos.x, pos.y, turret_ranges[entity[1].name])
            end
        end

        if not found then
            for i = 1, #glob.turret_range_entities do
                glob.turret_range_entities[i].destroy()
            end
            glob.turret_range_entities = {}
        end

    end

end)

